<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountDetails ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountDetails
 * @subpackage Arrays
 */
class ArrayOfAccountDetails extends AbstractStructArrayBase
{
    /**
     * The AccountDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountDetails[]
     */
    public $AccountDetails;
    /**
     * Constructor method for ArrayOfAccountDetails
     * @uses ArrayOfAccountDetails::setAccountDetails()
     * @param \StructType\AccountDetails[] $accountDetails
     */
    public function __construct(array $accountDetails = array())
    {
        $this
            ->setAccountDetails($accountDetails);
    }
    /**
     * Get AccountDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountDetails[]|null
     */
    public function getAccountDetails()
    {
        return isset($this->AccountDetails) ? $this->AccountDetails : null;
    }
    /**
     * Set AccountDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountDetails[] $accountDetails
     * @return \ArrayType\ArrayOfAccountDetails
     */
    public function setAccountDetails(array $accountDetails = array())
    {
        foreach ($accountDetails as $arrayOfAccountDetailsAccountDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountDetailsAccountDetailsItem instanceof \StructType\AccountDetails) {
                throw new \InvalidArgumentException(sprintf('The AccountDetails property can only contain items of \StructType\AccountDetails, "%s" given', is_object($arrayOfAccountDetailsAccountDetailsItem) ? get_class($arrayOfAccountDetailsAccountDetailsItem) : gettype($arrayOfAccountDetailsAccountDetailsItem)), __LINE__);
            }
        }
        if (is_null($accountDetails) || (is_array($accountDetails) && empty($accountDetails))) {
            unset($this->AccountDetails);
        } else {
            $this->AccountDetails = $accountDetails;
        }
        return $this;
    }
    /**
     * Add item to AccountDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountDetails $item
     * @return \ArrayType\ArrayOfAccountDetails
     */
    public function addToAccountDetails(\StructType\AccountDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountDetails) {
            throw new \InvalidArgumentException(sprintf('The AccountDetails property can only contain items of \StructType\AccountDetails, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AccountDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountDetails
     */
    public function getAttributeName()
    {
        return 'AccountDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAccountDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
